# 22jun23 Software Lab. Alexander Burger

(local) +Dt

# Date:Time Alarm
(class +Dt +Entity)
(rel key (+Key +Number))               # Key
(rel dat (+Aux +Ref +Date) (tim))      # Date
(rel tim (+Time))                      # Time
(rel ttl (+IdxFold +String))           # Title
(rel txt (+String))                    # Text
(rel cnt (+Number))                    # Count
(rel rpt (+Symbol))                    # Repeat

(dm T @
   (pass super 'key
      (or
         (pop (prop *DB 'key))
         (genKey 'key '+Dt NIL 100) ) ) )

(dm upd> (X Old)
   (cond
      ((not X)
         (alarm (: key))
         (push (prop *DB 'key) (: key)) )
      ((memq X '(dat tim))
         (alarm> This) ) )
   (super X Old) )

(dm alarm> ()
   (when (and (: dat) (: tim))
      (alarm (: key)
         (cons (: dat) (: tim))
         "wecker/alarm.l"
         (pack "wecker/App.l" "?*ID=" (ht:Fmt This)) ) ) )

(dm url> (Tab)
   (list "wecker/dt.l"  '*Tab Tab  '*ID This) )

# Database sizes
(dbs
   (1 +Dt)
   (3 (+Dt key dat ttl)) )
